Index: VoodooTSCSync.cpp
===================================================================
--- VoodooTSCSync.cpp	(revision 2)
+++ VoodooTSCSync.cpp	(working copy)
@@ -27,12 +27,32 @@
 	return true;
 }
 
+static IOPMPowerState powerStates[2] = {
+    {1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
+    {1, kIOPMPowerOn, kIOPMPowerOn, kIOPMPowerOn, 0, 0, 0, 0, 0, 0, 0, 0}
+};
+
+IOReturn org_voodoo_driver_VoodooTSCSync::setPowerState(unsigned long powerStateOrdinal, IOService *whatDevice ) {
+    if (powerStateOrdinal)
+        this->doTSC();
+    return IOPMAckImplied;
+}
+
+void org_voodoo_driver_VoodooTSCSync::stop(IOService *provider)
+{
+    PMstop();
+    super::stop(provider);
+}
+
+
 bool org_voodoo_driver_VoodooTSCSync::start(IOService *provider)
 
 {	
 	if (!super::start(provider)){ return false; }
 	countCalled = 0;
-	this->doTSC();
+    PMinit();
+    registerPowerDriver(this, powerStates, 2);
+    provider->joinPMtree(this);
 	return true;
 	
 }
Index: VoodooTSCSync.h
===================================================================
--- VoodooTSCSync.h	(revision 2)
+++ VoodooTSCSync.h	(working copy)
@@ -42,4 +42,7 @@
 
     virtual bool init(OSDictionary *dictionary = 0);
     virtual bool start(IOService *provider);
+    virtual void stop(IOService *provider);
+    virtual IOReturn setPowerState(unsigned long powerStateOrdinal, IOService *whatDevice);
+
 };
